/* HEXDUMP utility
 */

#include <stdio.h>
#include <string.h>

#define	BUFSIZE	16

unsigned char buf[BUFSIZE];

void
hexdump(char *label,unsigned char *buf,int offset, int len)
{
	int qty,i;
	unsigned char *p;
	char *out,dumpline[100];

	while (len > 0) {
		strcpy(dumpline,label);
		out = dumpline + strlen(label);
		qty = len;
		if (qty > 16)
			qty = 16;
		sprintf(out,"%04x  ",offset);
		out += 6;
		offset += qty;
		p = buf;
		for(i=qty ; i>0 ; i--) {
			sprintf(out,"%02x ",*p++);
			out += 3;
		}
		for(i=qty ; i<16 ; i++) {
			sprintf(out,"   ");
			out += 3;
		}
		*out++ = ' ';
		*out++ = '|';
		p = buf;
		for(i=qty ; i>0 ; i--) {
			if (*p > 0x1f && *p < 0x7f)
				*out++ = *p;
			else
				*out++ = '.';
			p++;
		}
		for(i=qty ; i<16 ; i++) {
				*out++ = ' ';
		}
		len -= qty;
		buf += qty;
		*out++ = '|';
		*out++ = '\n';
		*out = '\0';
/*
		write(1,dumpline,strlen(dumpline));
*/		printf(dumpline);
		out = dumpline;
	}
}

