/* I2C interface routines
 */

#define	I2C_OK		0		/* No error			*/
#define	I2C_ERR		1		/* Undefined I2C error		*/
#define	I2C_NOENT	2		/* Slave not responding		*/
#define	I2C_ELOST	3		/* Lost control of I2C bus	*/
#define	I2C_ETIMEOUT	4		/* Timeout			*/

extern int i2c_init(char *);
void i2c_uninit(int);
int i2c_reset(int);
int i2c_write(int, unsigned char, unsigned char *, int);
int i2c_read(int, unsigned char, unsigned char *, int);
void i2c_perror(char *);

extern	int	i2c_error;
extern int	i2c_verbose;

