#
# TCMK0601 / MSP3417D startup for Q-music, global configuration
#

# RX to Q-music
set if 33400
# Ether
rxset 100400
#Cable
#rxset 107900

# Init MSP3417
reset3417

# General programming demodulator

# AD_CV
#
# 15 .. 10 : not used, set to 0
#	9  : MSP Carrier Mute Function, 0
#	8  : SIF source, 0 (ANA_IN1+)
#	7  : Automatic Gain Constant, constant_gain:0 automatic_gain:1
#  6 .. 1  : Gain level / Gain reference, 
#	0  : not used, 0
#
# 15 14 13 12 11 10  9  8  7  6  5  4  3  2  1  0
# -----------------------------------------------
#  0  0  0  0  0  0  0  0  1  0  1  1  0  0  0  0
#
#  0  0  0  0  0  0  0  0  0  0  1  0  1  0  0  0
#
reg3417 dem 00bb 00d0

# FIR1
# -8 -8 4 6 78 107 (BW = 280 KHz)
reg3417 dem 0001 6b
reg3417 dem 0001 4e
reg3417 dem 0001 06
reg3417 dem 0001 04
reg3417 dem 0001 f8
reg3417 dem 0001 f8

# FIR2
# -8 -8 4 6 78 107
reg3417 dem 0005 4
reg3417 dem 0005 40
reg3417 dem 0005 0
reg3417 dem 0005 6b
reg3417 dem 0005 4e
reg3417 dem 0005 06
reg3417 dem 0005 04
reg3417 dem 0005 f8
reg3417 dem 0005 f8

# MODE_REG
#
#	15 : AM gain, 1 (12 db)
#	14 : ADR, 0 (normal)
#	13 : FIR1 set, 0 (use FIR1)
#	12 : MSP Ch 1 gain, 0 (6 db)
# 11 .. 10 : not used, 0
#	9  : HDEV, 0 (normal)
#	8  : FM/AM, 0 (FM)
#	7  : not used, 0
#	6  : MSP-Ch1 mode, 0 (FM)
#	5  : AUD_CL_OUT, 1 (tri-state)
#	4  : I2S_WS mode, 0 (Sony)
#	3  : I2S mode, 1 (slave)
#	2  : I2S_TRI, 1 (tri-state)
#	1  : DCTR_TRI, 1 (tri-state)
#	0  : not used, 0
#
# 15 14 13 12 11 10  9  8  7  6  5  4  3  2  1  0
# -----------------------------------------------
#  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
#
reg3417 dem 0083 0000

# DCO1
# 5.5 MHz: 0x4c638e
reg3417 dem 0093 38e
reg3417 dem 009b 4c6

# DCO2
# 5.5 MHz: 0x4c638e
reg3417 dem 00a3 38e
reg3417 dem 00ab 4c6

# ????
reg3417 dem 56 0
# 15 14 13 12 11 10  9  8  7  6  5  4  3  2  1  0
# -----------------------------------------------
#  0  0  0  0  1  0  0  0  0  0  0  0  0  0  0  1
reg3417 dem 0021 0801

# General programming audio programming unit

# DSP source
reg3417 dsp 000a 0020

# DSP matrix
reg3417 dsp 000e 7f00

# DSP SCART1 volume
reg3417 dsp 0007 6301

# DSP SCART switching
reg3417 dsp 0013 3f20

# QPD
reg3417 dsp 000c 0030

